"use strict";

exports.__esModule = true;
exports.default = MSUploader;
exports.messages = void 0;

var _dom = require("./tools/dom");

var _tab = require("./tools/tab");

var _tools = require("./tools/tools");

var _isNode = _interopRequireDefault(require("./tools/is-node"));

var _detectCamera = _interopRequireDefault(require("./tools/detect-camera"));

var _cropper = _interopRequireDefault(require("./cropper"));

var _uploader = _interopRequireDefault(require("./uploader"));

var _local = _interopRequireDefault(require("./local"));

var _camera = _interopRequireDefault(require("./camera"));

var _facebook = _interopRequireDefault(require("./sources/facebook"));

var _googlePhotos = _interopRequireDefault(require("./sources/google-photos"));

var _instagram = _interopRequireDefault(require("./sources/instagram"));

var _en = _interopRequireDefault(require("./locales/en"));

var _icons = require("./icons");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// EN by default
var messages = _en.default;
exports.messages = messages;

MSUploader.setMessages = function (m) {
  exports.messages = messages = m;
};

var TEMPLATE = function TEMPLATE() {
  return "<div class=\"popup\">\n<div class=\"popup-content\">\n<button type=\"button\" class=\"close\"></button>\n<div class=\"source-head\">\n  <div class=\"desc\">".concat(i18n('or_choose_from'), "</div>\n  <div class=\"tab\" data-target=\".crop-content\" style=\"display: none\" title=\"").concat(i18n('tab_crop'), "\">\n  ").concat(_icons.CROP_ICON, "</div>\n  <div class=\"tab active\" data-target=\".local-content\" title=\"").concat(i18n('tab_local'), "\">").concat(_icons.FILE_ICON, "</div>\n  <div style=\"display:none\" class=\"tab\" data-target=\".camera-content\" title=\"").concat(i18n('tab_camera'), "\">").concat(_icons.CAMERA_ICON, "</div>\n  <div class=\"tab source-tab\" data-key=\"facebook\" data-target=\".facebook-content\" title=\"").concat(i18n('tab_facebook'), "\">").concat(_icons.FACEBOOK_ICON, "</div>\n  <div class=\"tab source-tab\" data-key=\"googlePhotos\" data-target=\".google-photos-content\" title=\"").concat(i18n('tab_google_photos'), "\">").concat(_icons.GOOGLE_PHOTOS_ICON, "</div>\n  <div class=\"tab source-tab\" data-key=\"instagram\" data-target=\".instagram-content\" title=\"").concat(i18n('tab_instagram'), "\">").concat(_icons.INSTAGRAM_ICON, "</div>\n</div>\n<div class=\"source-body\">\n  <div class=\"flash\"></div>\n  <div class=\"back-to-menu link\">").concat(i18n('menu'), "</div>\n  <div style=\"display: none\" class=\"crop-content\">\n    <div class=\"preview\">\n      <div class=\"ctn\"><img crossorigin=\"anonymous\" /></div>\n      <div><div class=\"btn lesser back\">").concat(i18n('back'), "</div><div class=\"btn upload\">").concat(i18n('upload'), "</div></div>\n    </div>\n    <div class=\"actions\">\n      <div class=\"rotate\" data-add=\"-90\">").concat(_icons.ROTATE_LEFT_ICON, "</div>\n      <div class=\"rotate\" data-add=\"90\">").concat(_icons.ROTATE_RIGHT_ICON, "</div>\n      <div class=\"flip\" data-dir=\"h\">").concat(_icons.FLIP_H_ICON, "</div>\n      <div class=\"flip\" data-dir=\"v\">").concat(_icons.FLIP_V_ICON, "</div>\n      <div class=\"zoom\" data-zoom=\"+\">").concat(_icons.ZOOM_PLUS_ICON, "</div>\n      <div class=\"zoom\" data-zoom=\"-\">").concat(_icons.ZOOM_MINUS_ICON, "</div>\n    </div>\n    <div class=\"crop-container\">\n      <div class=\"media-container\">\n        <div class=\"img-container\">\n          <img crossorigin=\"anonymous\" />\n          <div class=\"cropper\">\n            <div data-pos=\"tl\" class=\"handle handle-tl\"></div>\n            <div data-pos=\"tr\" class=\"handle handle-tr\"></div>\n            <div data-pos=\"bl\" class=\"handle handle-bl\"></div>\n            <div data-pos=\"br\" class=\"handle handle-br\"></div>\n          </div>\n        </div>\n      </div>\n      <div class=\"wheel\" data-dir=\"h\">").concat((0, _icons.renderWheel)(true), "</div>\n      <div class=\"wheel\" data-dir=\"v\">").concat((0, _icons.renderWheel)(), "</div>\n    </div>\n    <div class=\"reset link\">").concat(i18n('reset'), "</div>\n    <div class=\"done btn\">").concat(i18n('ok'), "</div>\n  </div>\n  <div style=\"display: none\" class=\"local-content\">\n    <div class=\"drop-area\" data-help=\"").concat(i18n('drop_a_file'), "\">\n      <div class=\"lbl\">").concat(i18n('drag_n_drop'), "</div>\n      <div class=\"or\">").concat(i18n('or'), "</div>\n      <div class=\"file-btn btn\">\n        ").concat(i18n('choose_a_file'), "\n        <input type=\"file\" title=\"\" />\n      </div>\n    </div>\n  </div>\n  <div style=\"display: none\" class=\"camera-content\">\n    <div class=\"lbl\">").concat(i18n('camera_title'), "</div>\n    <div class=\"video-container\">\n      <div class=\"wrapper\">\n        <video class=\"video\"></video>\n        <div class=\"pic\"></div>\n        <div class=\"actions\">\n          <span class=\"flip\" data-dir=\"h\">").concat(_icons.FLIP_H_ICON, "</span>\n          <span class=\"flip\" data-dir=\"v\">").concat(_icons.FLIP_V_ICON, "</span>\n        </div>\n      </div>\n    </div>\n    <div class=\"stream-off\">\n      <button class=\"take-another-one btn lesser\">").concat(i18n('camera_another_one'), "</button>\n      <button class=\"use-it btn\">").concat(i18n('camera_use_it'), "</button>\n    </div>\n    <div class=\"stream-on\">\n      <button class=\"take-photo btn\">").concat(i18n('camera_take_photo'), "</button>\n    </div>\n  </div>\n  <div style=\"display: none\" class=\"direct-content\">\n  </div>\n  <div style=\"display: none\" class=\"source-content\">\n    <div style=\"display: none\" class=\"view albums\">\n      <div class=\"lbl\">").concat(i18n('albums_title'), "</div>\n      <div class=\"list\"></div>\n    </div>\n    <div style=\"display: none\" class=\"view photos\">\n      <div class=\"lbl album-name\">").concat(i18n('photos_title'), "</div>\n      <div class=\"action\"><span class=\"back link\">").concat(i18n('back'), "</span></div>\n      <div class=\"list\"></div>\n    </div>\n  </div>\n  <div style=\"display: none\" class=\"facebook-content source\">\n    <div class=\"view intro\">\n      <div class=\"lbl\">").concat(i18n('facebook_desc'), "</div>\n      <button class=\"connect btn\">").concat(i18n('facebook_btn'), "</button>\n    </div>\n  </div>\n  <div style=\"display: none\" class=\"google-photos-content source\">\n    <div class=\"view intro\">\n      <div class=\"lbl\">").concat(i18n('google_photos_desc'), "</div>\n      <button class=\"connect btn\">").concat(i18n('google_photos_btn'), "</button>\n    </div>\n  </div>\n  <div style=\"display: none\" class=\"instagram-content source\">\n    <div class=\"view intro\">\n      <div class=\"lbl\">").concat(i18n('instagram_desc'), "</div>\n      <button class=\"connect btn\">").concat(i18n('instagram_btn'), "</button>\n    </div>\n  </div>\n</div>\n</div>\n</div>");
};

var MANAGERS = {
  'crop-content': _cropper.default,
  'local-content': _local.default,
  'camera-content': _camera.default,
  'facebook-content': _facebook.default,
  'google-photos-content': _googlePhotos.default,
  'instagram-content': _instagram.default
};
var container;
var hasCamera = null;

function displayCameraTab(camera) {
  if (!container || null === camera) return hasCamera = camera;
  (camera ? _dom.show : _dom.remove)(container.querySelector('[data-target=".camera-content"]'));
}

(0, _detectCamera.default)(displayCameraTab);

function MSUploader(options) {
  if (_isNode.default) return;
  options = options || {};
  var cropperOptions = options.cropper || {};
  var ratio = cropperOptions.ratio;
  var minWidth = cropperOptions.minWidth;
  var minHeight = cropperOptions.minHeight;

  if (ratio && (minWidth || minHeight)) {
    if (!minWidth || minHeight && ratio.v > ratio.h) minWidth = minHeight * ratio.v / ratio.h;
    if (!minHeight || minWidth && ratio.v <= ratio.h) minHeight = minWidth * ratio.h / ratio.v;
    minWidth = Math.round(minWidth);
    minHeight = Math.round(minHeight);
  }

  var managers = {};
  var events = [];
  var oldTab, previousTab, manager, args; // Uploader

  var uploader = (0, _uploader.default)(options.uploader);

  var upload = function upload(file) {
    destroy();
    uploader.upload(file, options.uploader.data);
  }; // Inject HTML


  container = document.createElement('div');
  (0, _dom.addClass)(container, 'msu-ctn');
  container.innerHTML = TEMPLATE();
  var $ = (0, _tab.getQueryFunc)(container);
  var $$ = (0, _tab.getQueryAllFunc)(container); // Close

  events.push((0, _dom.on)(container, 'click', '.close', destroy));
  events.push((0, _dom.on)(container, 'click', function (e) {
    if (e.target === container) destroy();
  })); // Display tabs or not

  displayCameraTab(hasCamera);
  (0, _tools.each)($$('.source-tab'), function (source) {
    if (!options[source.getAttribute('data-key')]) (0, _dom.remove)(source);
  }); // Set device orientation

  events.push((0, _dom.on)(window, 'orientationchange', setOrientation));
  var resizeTimer;
  events.push((0, _dom.on)(window, 'resize', function () {
    clearTimeout(resizeTimer);
    resizeTimer = setTimeout(onResize, 100);
  }));
  setOrientation(); // Flash alert

  var flashTimer;
  var flashCtn = (0, _dom.hide)(container.querySelector('.flash')); // Manager args

  var gOptions = {
    container: container,
    upload: upload,
    onSelect: onSelect,
    flash: flash,
    i18n: i18n,
    options: options,
    minWidth: minWidth || 0,
    minHeight: minHeight || 0 // Manage tabs

  };
  var cropTab = $('[data-target=".crop-content"]');
  events.push((0, _dom.on)(container, 'click', '.tab', function (e) {
    setTab(e.currTarget);
  }), (0, _dom.on)(container, 'click', '.back-to-menu', function () {
    setTab($('[data-target=".local-content"]'));
  }));
  setTab(container.querySelector('.tab.active'), false);
  (options.parent || document.body).appendChild(container);

  function backToPreviousTab() {
    setTab(previousTab);
  }

  function setTab(tab, showCropTab) {
    ;
    (showCropTab ? _dom.show : _dom.hide)(cropTab);

    if (oldTab) {
      var oldTarget = oldTab.getAttribute('data-target');
      manager.onLeave();
      (0, _dom.hide)(container.querySelector(oldTarget));
      (0, _dom.removeClass)(oldTab, 'active');
    }

    var target = (0, _dom.addClass)(tab, 'active').getAttribute('data-target');
    container.setAttribute('data-tab', target);
    var tabContentElt = (0, _dom.show)($(target));
    var managerType = target.slice(1);
    manager = managers[managerType] = managers[managerType] || MANAGERS[managerType](tabContentElt, gOptions);
    manager.onEnter.apply(manager, args);
    previousTab = oldTab || tab;
    oldTab = tab;
  }

  function onSelect(dataURI, rot, flip) {
    args = [dataURI, rot, flip];
    setTab($('[data-target=".crop-content"]'), true);
  }

  function destroy() {
    manager.onLeave();
    (0, _tab.stopObserving)(events);
    (0, _dom.remove)(container);
  }

  function detectOrientation() {
    if (window.matchMedia) return matchMedia('(orientation: portrait)').matches ? 'portrait' : 'landscape';
    var screen = window.screen;
    var orientation = null;
    var portrait = false;

    if (screen) {
      if (screen.orientation) {
        var type = screen.orientation.type;
        if (type) return type.indexOf('portrait') >= 0 ? 'portrait' : 'landscape';
        orientation = screen.orientation.angle;
      } else {
        portrait = screen.height > screen.width;
      }
    }

    orientation = null !== orientation ? orientation : window.orientation;
    return (null != orientation ? 0 === orientation : portrait) ? 'portrait' : 'landscape';
  }

  function onResize() {
    if (setContainerHeight()) {
      manager.onOrientationChange && manager.onOrientationChange();
    }
  } // Fix height on Safari/iOs


  function setContainerHeight() {
    if (window.matchMedia && matchMedia('(orientation: landscape), (max-width: 759px), (max-height: 500px)')) {
      var change = container.style.height;
      container.style.height = '';

      if (window.innerHeight !== container.getBoundingClientRect().height) {
        container.style.height = "".concat(window.innerHeight, "px");
        window.scrollTo(0, 0);
        return true;
      }

      return !!change;
    }

    return false;
  }

  function setOrientation() {
    setTimeout(function () {
      (0, _dom.removeClass)(container, 'portrait');
      (0, _dom.removeClass)(container, 'landscape');
      (0, _dom.addClass)(container, detectOrientation());
      setContainerHeight();
      manager.onOrientationChange && manager.onOrientationChange();
    }, 200);
  }

  function flash(message, options) {
    options = options || {};
    if (options.back) backToPreviousTab();
    clearTimeout(flashTimer);
    flashCtn.className = "flash ".concat(options.type || 'danger');
    flashCtn.innerHTML = i18n(message, options.values);
    (0, _dom.show)(flashCtn);
    flashTimer = setTimeout(function () {
      return (0, _dom.hide)(flashCtn);
    }, 3000);
  }

  return {
    destroy: destroy
  };
}

function i18n(prop, values) {
  var msg = messages[prop];
  if (values) (0, _tools.each)(Object.keys(values), function (k) {
    msg = msg.replace(new RegExp("{".concat(k, "}")), values[k]);
  });
  return msg;
}

module.exports = MSUploader;