"use strict";

exports.__esModule = true;
exports.transform = transform;
exports.applyRatio = applyRatio;
exports.position = position;

var _isNode = _interopRequireDefault(require("./is-node"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TRANSFORM_PROP = _isNode.default ? false : function (style) {
  if (null != style.transform) return 'transform';
  var prefixes = ['Webkit', 'Moz', 'O', 'ms'];

  for (var i = 0, prop; prop = prefixes[i]; ++i) {
    if (null != style[prop += 'Transform']) return prop;
  }
}(document.createElement('div').style);

function transform(element, rot, flip, scale) {
  element.style[TRANSFORM_PROP] = "rotate(".concat(rot, "deg) scale(").concat(flip.h * scale, ", ").concat(flip.v * scale, ")");
}

function applyRatio(width, height, ratio) {
  var widthFit = width / height <= ratio.v / ratio.h;
  return {
    width: Math.round(widthFit ? width : height * ratio.v / ratio.h),
    height: Math.round(widthFit ? width * ratio.h / ratio.v : height)
  };
}

function position(style, coords) {
  style.top = "".concat(Math.round(coords.top), "px");
  style.left = "".concat(Math.round(coords.left), "px");
  style.width = "".concat(Math.round(coords.width), "px");
  style.height = "".concat(Math.round(coords.height), "px");
}