"use strict";

exports.__esModule = true;
exports.sendRequest = sendRequest;
exports.handleRequestStates = handleRequestStates;

function sendRequest(url, success, error) {
  var xhr = new XMLHttpRequest();
  handleRequestStates(xhr, function () {
    return success && success(JSON.parse(xhr.responseText));
  }, function () {
    return error && error(xhr);
  });
  xhr.open('get', url);
  xhr.send();
}

function handleRequestStates(xhr, success, error) {
  xhr.onreadystatechange = function () {
    if (4 === xhr.readyState) {
      if (xhr.status >= 200 && xhr.status < 300 || xhr.status === 304) {
        success(xhr);
      } else {
        error(xhr);
      }
    }
  };
}