"use strict";

exports.__esModule = true;
exports.getQueryFunc = getQueryFunc;
exports.getQueryAllFunc = getQueryAllFunc;
exports.getLoadingFunc = getLoadingFunc;
exports.stopObserving = stopObserving;

var _dom = require("./dom");

var _tools = require("./tools");

function getQueryFunc(container) {
  return function (selector, parent) {
    return (parent || container).querySelector(selector);
  };
}

function getQueryAllFunc(container) {
  return function (selector, parent) {
    return (parent || container).querySelectorAll(selector);
  };
}

function getLoadingFunc(container) {
  return function (state) {
    ;
    (state !== false ? _dom.addClass : _dom.removeClass)(container, 'loading');
  };
}

function stopObserving(events) {
  (0, _tools.each)(events, function (func) {
    func();
  });
}