"use strict";

exports.__esModule = true;
exports.default = uploader;

var _request = require("./tools/request");

var _dom = require("./tools/dom");

var _tools = require("./tools/tools");

function FN() {}

function uploader(options) {
  options = options || {};
  var stopEvent;
  var count = 0;

  function _upload(file, data) {
    var xhr = new XMLHttpRequest();
    var formData = new FormData();
    xhr.open(options.method || 'POST', options.url);
    var headers = options.headers || {};
    (0, _tools.each)(Object.keys(headers), function (name) {
      var value = headers[name];
      xhr.setRequestHeader(name, typeof value === 'function' ? value() : value);
    });
    var xhrUpload = xhr.upload;

    xhrUpload.onloadstart = function () {
      if (0 === count++) {
        stopEvent = (0, _dom.on)(window, 'beforeunload', function (e) {
          e.preventDefault();
          return e.returnValue = '';
        });
      }

      ;
      (options.onStart || FN)(file);
    };

    xhrUpload.onprogress = function (e) {
      ;
      (e.lengthComputable ? options.onProgress || FN : FN)(e.loaded / e.total * 100);
    }; // onloadend doesn't work with responseXML


    (0, _request.handleRequestStates)(xhr, function () {
      ;
      (options.onDone || FN)(xhr);
      if (1 === count--) stopEvent();
    }, function () {
      ;
      (options.onError || FN)(xhr);
      if (1 === count--) stopEvent();
    });
    (0, _tools.each)(Object.keys(data || {}), function (prop) {
      formData.append(prop, data[prop]);
    });
    formData.append(options.paramName || 'file', file, 'pic.jpg');
    xhr.send(formData);
  }

  return {
    upload: function upload(file, data) {
      options.getSignature ? options.getSignature(function (data) {
        return _upload(file, data);
      }) : _upload(file, data);
    }
  };
}